var gMediawrap = {

	init: function() {
		this.hasPlugins = {
			"WMP": false,
			"RP":  false,
			"QT":  false,
			"VLC": false,
			"SWF": false,
			"DCR": false
		};

		for (var i = 0; i < navigator.plugins.length; i++) {
			var player = this.searchPlayer(navigator.plugins[i].name);
			if ( player != "other" )
				this.hasPlugins[player] = true;
		}
	},

	isURIcharcter: /[!\$&'\(-;=\?-Z_a-z~]/,
	isDigit16:     /[0-9A-Fa-f]/,

	os: navigator.oscpu.indexOf("Windows")>-1 ? "win" : "other",

	fileExtensionsGenerated: ["php","asp","aspx","html","htm","jhtml","cgi","fcgi","cfm","pl","ps","rstp","rst"],

	defaultMimeType: {
		'WMP':   'application/x-mplayer2',
		'VLC':   'application/x-vlc-plugin',
		'RP':    'audio/x-pn-realaudio-plugin',
		'QT':    'video/quicktime',
		'SWF':   'application/x-shockwave-flash',
		'DCR':   'application/x-director',
		'other': 'otherType'
	},

	mimeTypeTable: {	// mimetype: [A/V, player1, player2, ...], extension
		// Windows Media
		'application/x-mplayer2': ['AV','WMP','VLC'],	// *
		'application/asx': ['A','WMP','VLC','RP'],	// *
		'video/x-ms-asf-plugin': ['AV','WMP','VLC'],	// *
		'video/x-ms-asf': ['AV','WMP','VLC','RP'],	// asf,asx,*
		'video/x-ms-wm': ['AV','WMP','VLC','RP'],	// wm,*
		'audio/x-ms-wma': ['A','WMP','VLC','RP'],	// wma,*
		'audio/x-ms-wax': ['A','WMP','VLC','RP'],	// wax,*
		'video/x-ms-wmv': ['AV','WMP','VLC','RP'],	// wmv,*
		'video/x-ms-wvx': ['AV','WMP','VLC','RP'],	// wvx,*
		'application/x-drm-v2': ['AV','WMP'],	// nip
		'application/x-drm': ['AV','WMP'],	// nip
		// VLC Media
		'application/x-vlc-plugin': ['AV','VLC','WMP'],
		'application/mpeg4-iod': ['AV','VLC'],
		'application/mpeg4-muxcodetable': ['AV','VLC'],
		'application/x-ogg': ['AV','VLC'],
		'audio/mpeg4': ['A','VLC','WMP'],
		'video/mpeg4': ['AV','VLC','WMP'],
		'video/mpeg-system': ['AV','VLC'],
		'video/x-mpeg-system': ['AV','VLC'],
		// real
		'audio/x-pn-realaudio-plugin': ['AV','RP'],	// rpm,*
		'audio/x-pn-realaudio': ['AV','RP'],
		'video/vnd.vivo': ['AV','RP'],
		'audio/vnd.rn-realaudio': ['AV','RP'],
		'audio/vnd.rn-realmedia': ['AV','RP'],
		'application/vnd.rn-realmedia': ['AV','RP'],
		'icm.div6': ['AV','RP'],	// divx
		'application/smil': ['AV','RP'],	// smi,smil
		'application/vnd.rn-realplayer-javascript': ['AV','RP'],	// rpj
		// quick time
		'video/quicktime': ['AV','QT','VLC','WMP','RP'],	// mov,qt,mqv,*
		'audio/mp4': ['A','QT','VLC','RP'],	// mp4
		'video/mp4': ['AV','QT','VLC','RP'],	// mp4
		'audio/x-m4a': ['A','QT','VLC','RP'],	// m4a
		'audio/x-m4p': ['A','QT','VLC','RP'],	// m4p
		'audio/x-m4b': ['A','QT','VLC','RP'],	// m4b
		'video/x-m4v': ['AV','QT','VLC','RP'],	// m4v
		'audio/mpeg': ['A','QT','VLC','WMP','RP'],	// mp3,swa
		'audio/x-mpeg': ['A','QT','VLC','WMP','RP'],	// mp3
		'audio/mp3': ['A','QT','WMP','VLC','RP'],	// mp3,swa
		'audio/x-mp3': ['A','QT','WMP','VLC','RP'],	// mp3,swa
		'audio/mpeg3': ['A','QT','WMP','VLC','RP'],	// mp3,swa
		'audio/x-mpeg3': ['A','QT','WMP','VLC','RP'],	// mp3,swa
		'application/x-mpeg': ['AV','QT','WMP','VLC','RP'],
		'video/3gpp': ['AV','QT','VLC','RP'],	// 3gp,3gpp
		'audio/3gpp': ['A','QT','VLC','RP'],	// 3gp,3gpp
		'video/3gpp2': ['AV','QT','VLC','RP'],	// 3g2,3gp2
		'audio/3gpp2': ['A','QT','VLC','RP'],	// 3g2,3gp2
		'video/sd-video': ['AV','QT'],	// sdv
		'application/x-mpeg': ['AV','QT','VLC','RP'],	// amc
		'audio/amr': ['A','QT','RP'],	// amr
		'audio/aac': ['A','QT','RP'],	// aac,adts
		'audio/x-aac': ['A','QT','RP'],	// aac,adts
		'audio/x-caf': ['A','QT'],	// caf
		'audio/x-dv': ['A','QT'],
		'audio/x-sd2': ['A','QT'],
		'video/x-mpeg': ['AV','QT','WMP','VLC','RP'],	// mpeg,mpg
		'video/mpeg': ['AV','QT','WMP','VLC','RP'],	// mpeg,mpg
		'video/mpg': ['AV','QT','WMP','VLC','RP'],	// mpeg,mpg
		'audio/vnd.qcelp': ['A','QT','RP'],	// qcp
		'audio/x-gsm': ['A','QT','RP'],	// gsm
		'application/sdp': ['AV','QT','RP'],	// DCR
		'application/x-sdp': ['AV','QT','RP'],	// DCR
		'application/x-rtsp': ['AV','QT','RP'],
		'video/x-msvideo': ['AV','QT','WMP','VLC','RP'],	// avi,vfw
		'video/msvideo': ['AV','QT','WMP','VLC','RP'],	// avi,vfw
		'video/avi': ['AV','QT','WMP','VLC','RP'],	// avi,vfw
		'video/x-sgi-movie': ['AV','QT','WMP','VLC'],
		'video/flc': ['AV','QT'],	// flc,fli,cel
		// WaveMidiAuAif
		'audio/aiff': ['A','QT','WMP','VLC','RP'],	// aiff,aif,aifc,cdda
		'audio/x-aiff': ['A','QT','WMP','VLC','RP'],	// aiff,aif,aifc,cdda
		'audio/basic': ['A','QT','WMP','VLC','RP'],	// au,snd,ulw
		'audio/mid': ['A','QT','WMP','VLC','RP'],	// mid,midi,smf,kar
		'audio/midi': ['A','QT','WMP','VLC','RP'],	// mid,midi,smf,kar
		'audio/x-midi': ['A','QT','WMP','VLC','RP'],	// mid,midi,smf,kar
		'audio/x-wav': ['A','QT','WMP','VLC','RP'],	// wav,bwf
		'audio/wav': ['A','QT','WMP','VLC','RP'],	// wav,bwf
		'audio/wave': ['A','QT','WMP','VLC','RP'],	// wav,bwf
		'audio/x-pn-wav': ['A','QT','WMP','VLC','RP'],	// wav,bwf
		// pls,m3u
		'audio/scpls': ['A','QT','WMP','VLC','RP'],
		'audio/pls': ['A','QT','WMP','VLC','RP'],
		'audio/x-scpls': ['A','QT','WMP','VLC','RP'],
		'audio/m3u': ['A','QT','WMP','VLC','RP'],
		'audio/x-mpegurl': ['A','QT','WMP','VLC','RP'],
		'audio/mpegurl': ['A','QT','WMP','VLC','RP'],
		'interface/x-tcmp-pls': ['A','QT','WMP','RP'],
		// Google Video Viewer
		'application/x-google-vlc-plugin': ['AV','GoogleVideoViewer','VLC','WMP'],
		// Shockwave Flash
		'application/x-shockwave-flash': ['AV','SWF'],	// swf
		'application/futuresplash': ['AV','SWF'],	// spl
		// Shockwave for Director
		'application/x-director': ['AV','DCR']	// dir,dxr,dcr
	},

	extsMimeTable: {
		'dll': 'application/x-mplayer2',
		'asr': 'application/x-mplayer2',
		'wpl': 'application/x-mplayer2',
		'wmd': 'application/x-mplayer2',
		'wmz': 'application/x-mplayer2',
		'mac': 'video/quicktime'
	},

	tagParamTable: [
		{'WMP':'autostart','QT':'autoplay','RP':'autostart','VLC':'autoplay','BG':'autostart','IMG':'autostart'},
		{'WMP':'autostart','QT':'autostart','RP':'autostart','VLC':'autostart'},
		{'WMP':'autoplay','QT':'autoplay','RP':'autostart','VLC':'autostart'},
		{'WMP':'playcount:10000:#','QT':'loop:true','RP':'loop:true','VLC':'loop:true','BG':'loop:-1:#','IMG':'loop:-1:#'},
		{'WMP':'playcount:10000:#','QT':'loop:true','RP':'loop:true','VLC':'loop:true','BG':'loop:infinite:#','IMG':'loop:infinite:#'},
		{'WMP':'playcount:1:#','QT':'loop:false','RP':'numloop:1:#','VLC':'loop:false'},
		{'WMP':'playcount','QT':'loop','RP':'numloop','VLC':'loop','BG':'loop','IMG':'loop'},
		//{'WMP':'showcontrols:false:#','QT':'controller:false:#','RP':'controls:none'},
		{'WMP':'showcontrols:true','QT':'controller:true','RP':'controls:controlpanel'},
		{'WMP':'displaybackcolor','QT':'bgcolor','RP':'backgroundcolor'},
		{'WMP':'uimode:invisible:#','QT':'hidden:true','RP':'hidden:true'},
		//{'WMP':'uimode:none:#','QT':'controller:false','RP':'controls:none'},
		{'WMP':'uimode:mini:#','QT':'controller:true','RP':'controls:controlpanel'},
		{'WMP':'uimode:full','QT':'controller:true','RP':'controls:tacctrl,statusbar,controlpanel'},
		{'WMP':'enabled:true','QT':'controller:true','RP':'controls:controlpanel'},
		{'WMP':'showaudiocontrols:true','QT':'controller:true','RP':'controls:controlpanel'},
		{'WMP':'enablepositioncontrols:true','QT':'controller:true','RP':'controls:positionfield'},
		{'WMP':'showpositioncontrols:true','QT':'controller:true','RP':'controls:positionfield'},
		{'WMP':'showstatusbar:true','QT':'controller:true','RP':'controls:statusbar'},
		{'WMP':'stretchtofit:true','QT':'scale:aspect:#','RP':'maintainaspect:true'},
		{'WMP':'stretchtofit:true','QT':'scale:tofit','RP':'maintainaspect:true'},
		{'WMP':'volume','QT':'volume','BG':'volume','VLC':'volume'},
		{'WMP':'mute:true','QT':'volume:0'}
	],

	globalAttributes: ['id','name','width','height','hidden',
		'align','border','hspace','vspace','class','dir','style','title'],

	boolTagParam: {
		'WMP':
			/^(?:auto|allow|enable|show|fullscreen|mute|clicktoplay|stretchtofit)/,
		'RP':
			/^(?:autogotourl|autostart|center|loop|maintainaspect|prefetch|shuffle)$/,
		'QT':
			/^(?:autohref|autoplay|autostart|controller|loop|kioskmode)$/,
		'VLC':
			/^(?:auto|enable|show|visible|loop|fullscreen|mute)/,
		'SWF':
			/^(?:swliveconnect|play|loop|menu)$/,
		'BG':
			/^(?:autostart)$/,
		'IMG':
			/^(?:autostart)$/
	},

	isBoolTagParam: function(pName, player) {
		if (this.boolTagParam[player])
			return this.boolTagParam[player].test(pName);
		else
			return false;
	},

	isFileExtensionsGenerated: function(ext) {
		return this.isInConcourse(ext, this.fileExtensionsGenerated)
	},

	isGlobalAttribute: function(attrName) {
		return this.isInConcourse(attrName, this.globalAttributes)
	},

	isInConcourse: function(o, ccs) {
		for (var i = 0; i < ccs.length; i++)
			if (o == ccs[i]) return true;
		return false;
	},

	searchPlayer: function(pluginName) {
		if (pluginName.indexOf("Windows Media")>-1 || pluginName.indexOf("Microsoft")>-1 
				|| pluginName.indexOf("Flip4Mac")>-1)
			return "WMP";
		else if (pluginName.indexOf("RealPlayer")>-1)
			return "RP";
		else if (pluginName.indexOf("QuickTime")>-1)
			return "QT";
		else if (pluginName.indexOf("VLC")>-1)
			return "VLC";
		else if (pluginName.indexOf("Shockwave Flash")>-1)
			return "SWF";
		else if (pluginName.indexOf("Director")>-1)
			return "DCR";
		else
			return "other";
	},

	getDefaultMimeType: function(player) {
		return this.defaultMimeType[player] ? this.defaultMimeType[player] : "";
	},

	getPlayerFromType: function(type) {
		if (type && navigator.mimeTypes[type] && navigator.mimeTypes[type].enabledPlugin)
			return this.searchPlayer(navigator.mimeTypes[type].enabledPlugin.name);
		else
			return "";
	},

	// return tPlayer(target player) & tType(target mime type), sType (source mime type)
	selectPlayerFromMimeType: function(sType) {
		if (this.tPlayer = this.getPlayerFromType(sType)) {
			this.tType = sType;
			return true;
		}
		else if (this.mimeTypeTable[sType]) {
			var player, dType;
			for (var i = 1; i < this.mimeTypeTable[sType].length; i++ ) {
				player = this.mimeTypeTable[sType][i];
				dType = this.getDefaultMimeType(player);
				if (this.hasPlugins[player] && (this.tPlayer = this.getPlayerFromType(dType))) {
					this.tType = this.getDefaultMimeType(this.tPlayer);
					return true;
				}
			}
		}
		this.tPlayer = "other";
		this.tType = sType;
		return false;
	},

	getFileNameFromURL: function (url) {
		if (!url) return "";
		if (url.indexOf("?") > -1)
			url = url.substring(0, url.indexOf("?"));
		return url.substring(url.lastIndexOf("/")+1, url.length);
	},

	getExtFromURL: function(url) {
		var fileName = this.getFileNameFromURL(url);
		if (!fileName || fileName.indexOf(".") == -1) return "";
		var ext = fileName.substring(fileName.lastIndexOf(".")+1, fileName.length);
		return ext ? ext.toLowerCase() : "";
	},

	getMimeTypeFromExt: function(ext) {
		var mimeSvc = Components.classes["@mozilla.org/mime;1"]
				.getService(Components.interfaces.nsIMIMEService);
		try {
			return mimeSvc.getTypeFromExtension(ext).toLowerCase();
		}
		catch (e) {
			return this.extsMimeTable[ext] ? this.extsMimeTable[ext] : "";
		}
	},

	// return tPlayer & tType
	smartSelectPlayer: function(sPlayer, sType, url, isAx) {
		if ( !url || !mediawrapSettings.getBoolPref('convertEachAuto', true) ) {
			this.tPlayer = sPlayer;
			this.tType = sType;
			return;
		}
		
		var ext = this.getExtFromURL(url);

		if (isAx && this.os == "win" && sPlayer != "BG" && sPlayer != "IMG") {
			if (this.selectPlayerFromMimeType(sType)) {
				if (this.tType == this.getDefaultMimeType(this.tPlayer)) return;
				if (this.isFileExtensionsGenerated(ext)) {
					// is FileExtensionsGenerated
					this.tType = this.getDefaultMimeType(this.tPlayer);
				}
				else {
					var type = this.getMimeTypeFromExt(ext);
					if (!type)
						this.tType = this.getDefaultMimeType(this.tPlayer);
					else if (!this.selectPlayerFromMimeType(type))
						this.selectPlayerFromMimeType(sType);
				}
				return;
			}
		}

		if (this.isFileExtensionsGenerated(ext)) {
			if (this.selectPlayerFromMimeType(sType)) return;
		}
		var type = this.getMimeTypeFromExt(ext);
		if (!type) {
			if (this.selectPlayerFromMimeType(sType)) return;
		}
		if (!this.selectPlayerFromMimeType(type))
			this.selectPlayerFromMimeType(sType);
	},

	checkAudio: function(url,type) {
		var ext = this.getExtFromURL(url);
		if (ext) {
			var mType = this.getMimeTypeFromExt(ext);
			if (this.mimeTypeTable[mType]) {
				return ("A" == this.mimeTypeTable[mType][0] ? true : false);
			}
		}
		if (this.mimeTypeTable[type])
			return this.mimeTypeTable[type][0]=="A" ? true : false;
		else
			return false;	
	},

	// return sPlayer & sType & url
	checkPlayer: function(obj, charset) {
		this.url = this.getURL(obj, charset);
		this.sType = obj.getAttribute("type");
		
		if (this.sPlayer = this.getPlayerFromTypeTable(this.sType))
			return;
		
		var ext = this.getExtFromURL(this.url);
		if (ext && !this.isFileExtensionsGenerated(ext))
			this.sType = this.getMimeTypeFromExt(ext);

		if (this.sPlayer = this.getPlayerFromTypeTable(this.sType))
			return;
		
		this.sPlayer = "other";
		this.sType = "otherType";
	},

	getPlayerFromTypeTable: function(type) {
		if (type) {
			type = type.toLowerCase();
			if (this.mimeTypeTable[type])
				return this.mimeTypeTable[type][1];
		}
		return "";
	},

	gURL: function (obj) {
		switch (obj.nodeName) {
			case "OBJECT":
				if (!obj.getAttribute("classid"))
					return obj.getAttribute("data");
				var params=obj.getElementsByTagName("param");
				var pName, value;
				for (var p = params.length-1; p >= 0; p--) {
					pName = params[p].getAttribute("name");
					value = params[p].getAttribute("value");
					if(!pName || !value) continue;
					pName = pName.toLowerCase();
					if (pName=="src" || pName=="filename" || pName=="url" || pName=="movie") {
						params[p].parentNode.removeChild(params[p]);
						return value;
					}
				}
				return "";
			case "EMBED":
				var url = obj.getAttribute("src");
				if (!url) {
					url = obj.getAttribute("target");	// VLC plugins
					try {obj.removeAttribute("target")} catch(e){};
				}
				return url;
			case "BGSOUND":
				return obj.getAttribute("src");
			case "IMG":
				var url = obj.getAttribute("dynsrc");
				obj.removeAttribute("dynsrc");
				return url;
		}
		return "";
	},

	getURL: function (obj, charset) {
		var url = this.gURL(obj);
		return url ? (charset ? this.convertURL(url, charset) : url) : "";
	},

	convertURL: function (url, charset) {
		if (!url || this.isLocalLink(url)) return url;
		return this.encodeURI(url, charset);
	},

	isLocalLink: function (url) {
		if (!url) return false;
		var index = url.indexOf("://");
		if (index > -1 && index < 8) {
			if (url.indexOf("file:///")==0)
				return true;
		}
		else {
			var href = "";
			try { href = content.document.location.href } catch(e){}
			if (href && href.indexOf("file:///")==0)
				return true;
		}
		return false;
	},

	creatRpmURL: function (url) {
		if ( !url || /^data:/i.test(url) ) return url;
		var ext = this.getExtFromURL(url);
		if ( "rpm" == ext || "ram" == ext || "rpj" == ext
			|| "rm" == ext || "rmvb" == ext ) return url;
		if (this.isFileExtensionsGenerated(ext)) return url;
		return "data:text/plain," + this.getAbsURL(url);
	},

	getAbsURL: function (url) {
		if (!url || url.indexOf("://")>0 && url.indexOf("://")<8)
			return url;
		var str = "";
		try { str = content.document.location.href; } catch(e){}
		if (/^\/+/.test(url))
			str = str.substring(0, str.search(/[^:\/]\//)+1);
		else 
			str = str.substring(0,str.lastIndexOf("/")+1);
		return str + url;
	},

	encodeURI: function (url, charset) {

		var converter = Components.classes["@mozilla.org/intl/saveascharset;1"]
				.createInstance(Components.interfaces.nsISaveAsCharset);
		converter.Init(charset, null, null);

		url = url.replace(/^\s+/,"").replace(/\s+$/,"").replace(/\\/g,"/");

		var str, url1 = "";
		var ss = url.replace(/(\/+)/g,"$1/|/").split(/\/\|\//);
		for ( var i = 0; i < ss.length; i++ ) {
			try {
				str = decodeURI(ss[i]);
			} 
			catch(e) {
				str = ss[i];
			}

			if ( this.needEncode(str) ) {
				try {
					str = converter.Convert(str);
				} catch(e) {}
				var s;
				for (var j = 0; j < str.length; j++) {
					s = str.charAt(j);
					if ( this.isURIcharcter.test(s) ) {
						url1 += s;
					}
					else
						url1 += "%" + str.charCodeAt(j).toString(16);
				}
			}
			else {
				url1 += str;
			}
		}
		return url1;
	},

	needEncode: function (str) {
		var s;
		for (var i = 0; i < str.length; ) {
			s = str.charAt(i++);
			if (this.isURIcharcter.test(s)) continue;
			if ("%" == s) {
				s = str.charAt(i++);
				if (this.isDigit16.test(s)) {
					s = str.charAt(i++);
					if (this.isDigit16.test(s)) continue;
				}
			}
			return true;
		}
		return false;
	},

	regulationParams: function (obj, charset, player, isAttr) {
		if (isAttr && "OBJECT"==obj.nodeName) {
			obj.removeAttribute("classid");
			obj.removeAttribute("codebase");
			obj.removeAttribute("standby");
		}

		var pName, value;
		var params = isAttr ? obj.attributes : obj.getElementsByTagName("param");
		for (var p = params.length-1; p >= 0; p--) {
			pName = isAttr ? params[p].name : params[p].getAttribute("name");
			value = isAttr ? params[p].value : params[p].getAttribute("value");

			// Unavailability params can crash the firefox, remove it.
			if (!pName || /([^\w\-]|samistyle|samilang)/i.test(pName)) {
				if (isAttr)
					try {obj.removeAttribute(pName)} catch(e){}
				else
					params[p].parentNode.removeChild(params[p]);
				continue;
			}

			if (!value) continue;

			pName = pName.toLowerCase();
			if ("base"==pName || "baseurl"==pName || "href"==pName || "qtsrc"==pName
					|| "urlsubstitute"==pName || "samifilename"==pName
					|| pName.indexOf("hotspot")==0 || pName.indexOf("qtnext")==0) {
				obj.setAttribute(pName, this.convertURL(value, charset));
			}
			else if ("WMP"==player && pName == "playcount") {
				value = parseInt(value);
				value = isNaN(value) ? "loop" : (value > 1 ? value : 1);
				obj.setAttribute("playcount", value);
			}
			else if (pName == "volume") {
				obj.setAttribute("volume", this.convertVolume(value));
			}
			else if (this.isBoolTagParam(pName, player)) {
				value = this.convertFromBool(value, player);
				obj.setAttribute(pName, this.convertToBool(value, player));
			}
			else if (!isAttr)
				obj.setAttribute(pName, value);

			if (!isAttr)
				params[p].parentNode.removeChild(params[p]);
		}
	},

	convertVolume: function (volume) {
		if (!volume) return 100;
		volume = parseInt(volume);
		if (volume < 0)
			volume = parseInt((volume + 10000)/100);
		return (volume > 100) ? 100 : volume;
	},

	convertFromBool: function (value, player) {
		if (player == "VLC")
			return /^(?:yes|true)$/i.test(value) ? "true" : (new Boolean(parseInt(value))).toString();
		else
			return /^true$/i.test(value) ? "true" : (new Boolean(parseInt(value))).toString();
	},

	convertToBool: function (value, player) {
		if (player == "WMP")
			return /^false$/i.test(value) ? "0" : ((parseFloat(value) == 0) ? "0" : "1");
		else
			return /^true$/i.test(value) ? "true" : (new Boolean(parseInt(value))).toString();
	},

	convertAttrToAnother: function(obj, sPlayer, tPlayer, attrName, attrValue) {
		var attr, newAttr;
		for (var i = 0; i < this.tagParamTable.length; i++) {
			if (!this.tagParamTable[i][sPlayer]) continue;
			attr = this.tagParamTable[i][sPlayer].split(":");
			if (attr[0] != attrName) continue;
			if (this.isBoolTagParam(attrName, sPlayer)) {
				attrValue = this.convertFromBool(attrValue, sPlayer);
			}
			else
				attrValue = attrValue.toLowerCase();
			if (attr[1] == null || attr[1] == attrValue) {
				if (!this.tagParamTable[i][tPlayer]) break;
				newAttr = this.tagParamTable[i][tPlayer].split(":");
				if (newAttr[1])
					attrValue = newAttr[1];
				if (this.isBoolTagParam(newAttr[0], tPlayer))
					obj.setAttribute(newAttr[0], this.convertToBool(attrValue, tPlayer));
				else {
					if (obj.getAttribute(newAttr[0]))
						attrValue = this.concatAttr(obj.getAttribute(newAttr[0]), attrValue);
					obj.setAttribute(newAttr[0], attrValue);
				}
				return;
			}
			else if (attr[2] != "#")
				break;
		}
	},

	concatAttr: function(attr1, attr2) {
		var s = attr1;
		var s1 = attr1.split(",");
		var s2 = attr2.split(",");
		for (var i = 0; i < s1.length; i++) {
			s1[i] = s1[i].replace(/^\s+/,"").replace(/\s+$/,"");
			for (var j = 0; j < s2.length; j++) {
				s2[j] = s2[j].replace(/^\s+/,"").replace(/\s+$/,"");
				if (s1[i] == s2[j])
					s2[j] = "";
			}
		}
		for (var j = 0; j < s2.length; j++) {
			if (s2[j]) {
				s += (s ? "," : "") + s2[j];
			}
		}
		return s;
	}
}

gMediawrap.init();


function mediawrapCheckMedia() {
	this.defaultVideoWidth = "320"	// default Video Player Width
	this.defaultAudioWidth = "100%"	// default Audio Player Width
}

mediawrapCheckMedia.prototype = {

	checkObject: function(obj) {
		this.sPlayer = "other";
		if (obj.getAttribute("classid")) {
			switch (obj.getAttribute("classid").toLowerCase()) {
				case "clsid:05589fa1-c356-11ce-bf01-00aa0055595a":	// wmp6
				case "clsid:22d6f312-b0f6-11d0-94ab-0080c74c7e95":	// wmp6.4
				case "clsid:6bf52a52-394a-11d3-b153-00c04f79faa6":	// wmp7&9&10
					if ( mediawrapSettings.getBoolPref('convertWindowsMediaAx', true) ) {
						this.sPlayer = "WMP";
					}
					break;
				case "clsid:cfcdaa03-8be4-11cf-b84b-0020afbbccfa":	// real player
					if ( mediawrapSettings.getBoolPref('convertRealAx', true) ) {
						this.sPlayer = "RP";
					}
					break;
				case "clsid:02bf25d5-8c17-4b23-bc80-d3488abddc6b":	// quicktime player
					if ( mediawrapSettings.getBoolPref('convertQuickTimeAx', true) ) {
						this.sPlayer = "QT";
					}
					break;
				case "clsid:d27cdb6e-ae6d-11cf-96b8-444553540000":	// shockwave flash player
					if ( mediawrapSettings.getBoolPref('convertShockwaveFlashAx', true) ) {
						this.sPlayer = "SWF";
					}
					break;
				case "clsid:166b1bca-3f9c-11cf-8075-444553540000":	// shockwave Director player
					if ( mediawrapSettings.getBoolPref('convertShockwaveDirectorAx', true) ) {
						this.sPlayer = "DCR";
					}
					break;
			}
			this.sType = gMediawrap.getDefaultMimeType(this.sPlayer);
			
			if (this.sPlayer != "other") {
				this.convertObjectAx(obj);
			}
			else if ( mediawrapSettings.getBoolPref('convertEmbed', true) ) {
				this.triggerEmbed(obj);
			}
		}
		else if ( mediawrapSettings.getBoolPref('convertObjectNoClassId', true) ) {
			this.convertObjNoClassId(obj);
		}
	},

	checkEmbed: function(obj) {
		this.convertObjNoClassId(obj);
	},

	convertObjNoClassId: function(obj) {
		gMediawrap.checkPlayer(obj, this.charset);
		this.sPlayer = gMediawrap.sPlayer;
		this.sType = gMediawrap.sType;
		this.url = gMediawrap.url;
		if ( this.sPlayer != "other" )
			this.convertObject(obj);
		else
			this.triggerEmbed(obj);
	},

	convertObjectAx: function (obj) {
		this.url = gMediawrap.getURL(obj, this.charset);
		this.convertObject(obj, true);
	},

	convertObject: function(obj, isAx) {
		if ( this.url || obj.id || ("EMBED"==obj.nodeName ? obj.name : false) ) {
			gMediawrap.regulationParams(obj, this.charset, this.sPlayer, true);
			if ("OBJECT"==obj.nodeName)
				gMediawrap.regulationParams(obj, this.charset, this.sPlayer);
			this.isAudio = gMediawrap.checkAudio(this.url, this.sType);
			gMediawrap.smartSelectPlayer(this.sPlayer, this.sType, this.url, isAx);
			this.tPlayer = gMediawrap.tPlayer;
			this.tType = gMediawrap.tType;
			this.checkSize(obj);
			this.covertPlayer(obj);
		}
		else
			this.triggerEmbed(obj);
	},

	convertBgsound: function (bgsd) {
		this.sPlayer = "BG";
		this.isAudio = true;
		this.url = gMediawrap.getURL(bgsd, this.charset);
		if (!this.url) return;
		gMediawrap.smartSelectPlayer("BG", "other", this.url);
		this.tPlayer = gMediawrap.tPlayer;
		this.tType = gMediawrap.tType;
		if (this.tPlayer != "BG") {
			bgsd.setAttribute("autostart","1");
			bgsd.setAttribute("width","0");
			bgsd.setAttribute("height","0");
			var volume = bgsd.getAttribute("volume");
			bgsd.setAttribute("volume", gMediawrap.convertVolume(volume));
			this.covertPlayer(bgsd);
		}
	},

	convertDynsrcImg: function (dynimg) {
		this.sPlayer = "IMG";
		this.url = gMediawrap.getURL(dynimg, this.charset);
		if (!this.url) return;
		gMediawrap.smartSelectPlayer("IMG", "other", this.url);
		this.tPlayer = gMediawrap.tPlayer;
		this.tType = gMediawrap.tType;
		if (this.tPlayer != "IMG") {
			this.isAudio = gMediawrap.checkAudio(this.url, this.tType);
			this.checkSize(dynimg);
			this.covertPlayer(dynimg);
		}
	},

	triggerEmbed: function (obj) {
		var embs = obj.getElementsByTagName("embed");
		for ( var i = embs.length-1; i >= 0; i-- ) {
			try {embs[i].getAttribute("src")} catch(e){}
		}
	},

	insertVlcCtrl: function () {
		var text = mediawrapUtils.getContents("chrome://mediawrap/content/mediawrapVlcControl.js");
		mediawrapUtils.execScript(text);

		text = mediawrapUtils.getContents("chrome://mediawrap/content/mediawrapVlcInsertButton.js")
				.replace(/#PlayerName#/g, this.vlcPlayerName);
		mediawrapUtils.execScript(text);
	},

	getVlcPlayerName: function (obj) {
		if (this.tPlayer != "VLC") return;
		var pName = obj.nodeName=="OBJECT" ? "id" : "name";
		if ( (!obj.getAttribute("visible") && !obj.getAttribute("showdisplay"))
				|| gMediawrap.convertFromBool(obj.getAttribute("visible"), "VLC")
				|| gMediawrap.convertFromBool(obj.getAttribute("showdisplay", "VLC")) ) {
			var playerName = obj.getAttribute(pName);
			if (!playerName) {
				playerName = "Player" + (new Date()).getTime();
				obj.setAttribute(pName,playerName);
			}
			this.vlcPlayerName = playerName;
		}
	},

	covertPlayer: function (obj) {

		switch (obj.nodeName) {
			case "OBJECT":
				objName = "object";
				objSrcName = "data";
				obj.removeAttribute("data")
				break;
			case "BGSOUND":
			case "EMBED":
			case "IMG":
				objName = "embed";
				objSrcName = "src";
				obj.removeAttribute("src")
		}

		this.vlcPlayerName = "";

		if (this.tPlayer == "RP")
			this.url = gMediawrap.creatRpmURL(this.url);

		if (this.tPlayer == "WMP" && this.url && this.url.indexOf("?") >= 0)
			this.url = gMediawrap.getAbsURL(this.url);

		if (this.tPlayer != this.sPlayer) {
			var newObj = content.document.createElement(objName);
			var attrName,attrValue;
			for (var i = obj.attributes.length-1; i >= 0; i--) {
				attrName = obj.attributes[i].name;
				attrValue = obj.attributes[i].value;
				if (!attrValue) continue;
				if (gMediawrap.isGlobalAttribute(attrName)) {
					newObj.setAttribute(attrName, attrValue);
				}
				else {
					gMediawrap.convertAttrToAnother(newObj, this.sPlayer, this.tPlayer, attrName, attrValue);
				}	
			}

			if (this.tPlayer == "RP") {
				if (!newObj.getAttribute("controls"))
					newObj.setAttribute("controls", "default");
				this.checkSize(newObj);
			}

			this.setNewParams(newObj, objSrcName);
			
			if (this.tPlayer == "RP" && !this.isAudio) {
				newObj.setAttribute("height", this.getControlHeight(newObj, "RP"));
				newObj.setAttribute("console", "clip_" + (new Date()).getTime());
				var newObj1 = newObj.cloneNode(true);
				newObj1.setAttribute("controls","ImageWindow");
				newObj1.setAttribute("height",this.videoHeight);
				obj.parentNode.insertBefore(newObj1, obj);
				obj.parentNode.insertBefore(content.document.createElement("br"), obj);
			}

			obj.parentNode.insertBefore(newObj, obj);
			obj.setAttribute("mediawrapType", "removed");
		}
		else {
			this.setNewParams(obj, objSrcName);
		}

		if (this.vlcPlayerName)
			try { this.insertVlcCtrl() } catch (e){}
	},

	setNewParams: function(obj, objSrcName) {
		if (this.url)
			obj.setAttribute(objSrcName, this.url);
		if (this.tType)
			obj.setAttribute("type", this.tType);

		obj.setAttribute("mediawrapChecked","true");
		
		this.showWmpControl(obj);
		this.checkAutoStart(obj);
			
		this.getVlcPlayerName(obj);
	},

	showWmpControl: function (obj) {

		if (this.tPlayer != "WMP") return;

		if ( mediawrapSettings.getBoolPref('alwaysShowWmpControl', true) ) {
			var attrNames = ["enabled","showcontrols","showaudiocontrols"];
			for (var i = 0; i < attrNames.length; i++) {
				obj.removeAttribute(attrNames[i]);
			}
			var attrValue = obj.getAttribute("uimode");
			if (attrValue && "none" == attrValue.toLowerCase())
				obj.setAttribute("uimode", "full");
		}

		if ( mediawrapSettings.getBoolPref('alwaysShowWmpContextMenu', true) ) {
			obj.removeAttribute("enablecontextmenu");
		}
	},

	checkAutoStart: function (obj) {
		if ("WMP" == this.tPlayer && !obj.getAttribute("autostart") && obj.getAttribute("autoplay")) {
			var astart = gMediawrap.convertFromBool(obj.getAttribute("autoplay"),"WMP");
			obj.removeAttribute("autoplay");
			obj.setAttribute("autostart", gMediawrap.convertToBool(astart,"WMP"));
		}

		if (this.url)
			this.triggerEmbed(obj);

		if ( gMediawrap.isLocalLink(this.url) && mediawrapSettings.getBoolPref('autoStartLocalLinks', true) )
			return;

		if ( "SWF"==this.sPlayer ) {
			if (!mediawrapSettings.getBoolPref('autoStartFlash', true)) {
				obj.setAttribute("mediawrapType", "flash");
				this.replaceURL(obj);
			}
			return;
		}

		if ( "DCR"==this.sPlayer ) {
			if (!mediawrapSettings.getBoolPref('autoStartDirector', true)) {
				obj.setAttribute("mediawrapType", "director");
				this.replaceURL(obj);
			}
			return;
		}

		if ( mediawrapSettings.getBoolPref('autoStartEnabled', true) ) return;
		
		if ( mediawrapSettings.getBoolPref('autoStartBgSound', true) ) {
			if ( obj.getAttribute("hidden") && obj.getAttribute("hidden").toLowerCase() == "true"
				|| obj.getAttribute("height") == "0" || obj.getAttribute("width") == "0" )
				return;
		}

		switch (this.tPlayer) {
			case "QT":
			case "VLC":
				obj.setAttribute("autoplay", "false");
				obj.removeAttribute("autostart");
				break;
			default:
				obj.setAttribute("autostart", gMediawrap.convertToBool("false",this.tPlayer));
				obj.removeAttribute("autoplay");
		}
	},

	replaceURL: function (obj) {
		var srcTagName = (obj.nodeName == "OBJECT") ? "data" : "src";

		if (this.url) {
			obj.setAttribute("origSrc", this.url);
			obj.removeAttribute(srcTagName);
		}

		this.setPlaceholder = true;
		this.triggerEmbed(obj);
	},

	getRealSize: function (obj, sizeName) {
		var value = obj.getAttribute(sizeName);
		if (!value) {
			value = getComputedStyle(obj, null).getPropertyValue(sizeName);
			value = /^(\d+%?)(?:px)?$/.test(value) ? RegExp.$1 : "";
			if (value) {
				obj.setAttribute(sizeName, value);
			}
		}
		return value;
	},

	checkSize: function (obj) {
		var hide = obj.getAttribute("hidden");
		if ( hide && hide.toLowerCase() == "true" ) return;

		var width = this.getRealSize(obj, "width");
		var height = this.getRealSize(obj, "height");

		if (width && height && this.sPlayer == this.tPlayer) return;

		if (width && width.indexOf("%")==-1 && height && height.indexOf("%")==-1) {
			if (this.isAudio) {
				var hgt = this.getControlHeight(obj, this.tPlayer);
				obj.setAttribute("height", (height > hgt ? height : hgt));
			}
			else {
				width = parseInt(width);
				this.videoHeight = height = this.getVideoHeight(obj, parseInt(height));
				if (height < 50 || width/height >= 4) {
					this.isAudio = true;
					height = 0;
				}
				height += this.getControlHeight(obj, this.tPlayer)
				obj.setAttribute("height", height);
			}
		}
		else if ((!width || width.indexOf("%")>-1)&&(!height || height.indexOf("%")>-1)) {
			if (this.isAudio) {
				if (!width)
					obj.setAttribute("width", this.defaultAudioWidth);
				obj.setAttribute("height", this.getControlHeight(obj, this.tPlayer));
			}
			else {
				obj.setAttribute("width", this.defaultVideoWidth);
				this.videoHeight = parseInt(parseInt(this.defaultVideoWidth)*3/4);
				obj.setAttribute("height", 
						this.videoHeight + this.getControlHeight(obj, this.tPlayer));
			}
		}
		else if (width && width.indexOf("%")==-1) {
			if (this.isAudio) {
				obj.setAttribute("height", this.getControlHeight(obj, this.tPlayer));
			}
			else {
				this.videoHeight = parseInt(parseInt(width)*3/4);
				height = this.videoHeight + this.getControlHeight(obj, this.tPlayer);
				obj.setAttribute("height", height);
			}
		}
		else {
			this.videoHeight = height = this.getVideoHeight(obj, parseInt(height));
			if (height < 50) {
				this.isAudio = true;
				height = 0;
			}
			height += this.getControlHeight(obj, this.tPlayer)
			obj.setAttribute("height", height);
			obj.setAttribute("width", "100%");
		}
	},

	getVideoHeight: function (obj, height) {
		var ctrlHeight = this.getControlHeight(obj, this.sPlayer);
		ctrlHeight = parseInt(ctrlHeight*height/(ctrlHeight+height));
		return ((height - ctrlHeight)<1) ? 1 : (height - ctrlHeight);
	},

	getControlHeight: function (obj, player) {
		var ctrlHeight = 0;
		switch (player) {
			case "WMP":
				if ( !(obj.getAttribute("enabled")||obj.getAttribute("showcontrols")
					|| obj.getAttribute("showaudiocontrols")||obj.getAttribute("uimode"))
					|| gMediawrap.convertFromBool(obj.getAttribute("enabled")) == "true"
					|| gMediawrap.convertFromBool(obj.getAttribute("showcontrols")) == "true"
					|| gMediawrap.convertFromBool(obj.getAttribute("showaudiocontrols")) == "true"
					|| (obj.getAttribute("uimode") && (obj.getAttribute("uimode").toLowerCase() == "mini"
					|| obj.getAttribute("uimode").toLowerCase() == "full")) )

					ctrlHeight += 44;

				if (gMediawrap.convertFromBool(obj.getAttribute("showstatusbar")) == "true")
					ctrlHeight += 23;

				return ctrlHeight;

			case "RP":
				var ctrlValue = obj.getAttribute("controls");

				if (!ctrlValue) return ctrlHeight;

				if (/(?:ControlPanel|all|default|FFCtrl|HomeCtrl|MuteCtrl|PauseButton|PlayButton|PlayOnlyButton|RWCtrl|StopButton)/i.test(ctrlValue))
					ctrlHeight += 24;	//36
				if (/(?:StatusBar|all|default|PositionSlider|PositionField|StatusField)/i.test(ctrlValue))
					ctrlHeight += 20;	//30
				if (/(?:TACCtrl|all|default)/i.test(ctrlValue))
					ctrlHeight += 20;	//32
				if (/(?:InfoPanel|InfoVolumePanel|VolumeSlider|MuteVolume)/i.test(ctrlValue))
					ctrlHeight += 40;	//55
				return ctrlHeight;

			case "QT":
				if (!obj.getAttribute("controller") || 
						gMediawrap.convertFromBool(obj.getAttribute("controller")) == "true")
					ctrlHeight += 16;
				return ctrlHeight;

			default: 
				return ctrlHeight;
		}
	},

	go: function(aObj, charSet) {
		this.setPlaceholder = false;
		this.charset = charSet;
		this.url = null;

		switch (aObj.nodeName) {
			case "OBJECT":
				this.checkObject(aObj);
				break;

			case "EMBED":
				if ( mediawrapSettings.getBoolPref('convertEmbed', true) ) {
					this.checkEmbed(aObj);
				}
				break;

			case "BGSOUND":
				if ( mediawrapSettings.getBoolPref('convertBgSound', true) 
						&& mediawrapSettings.getBoolPref('autoStartBgSound', true) ) {
					this.convertBgsound(aObj);
				}
				break;

			case "IMG":aObj.removeAttribute("name");
				if ( mediawrapSettings.getBoolPref('convertDynsrcImg', true) ) {
					this.convertDynsrcImg(aObj);
				}
				break;
		}
	}
}

