var mediawrapSettings = {

	getBoolPref: function(prefName, defaultPref) {
		var prefService = Components.classes['@mozilla.org/preferences-service;1']
				.getService(Components.interfaces.nsIPrefService).getBranch('extensions.mediawrap.settings.');

		try {
			return prefService.getBoolPref(prefName);
		}
		catch (e) {
			return defaultPref;
		}
	},

	setBoolPref: function(prefName, prefValue) {
		var prefService = Components.classes['@mozilla.org/preferences-service;1']
				.getService(Components.interfaces.nsIPrefService).getBranch('extensions.mediawrap.settings.');

		prefService.setBoolPref(prefName, prefValue);
	},

	onLoad: function() {

		this.checkboxMediawrapEnabled = document.getElementById('mediawrapEnabled');
		this.checkboxMediawrapEnabled.checked = this.getBoolPref('mediawrapEnabled', true);
		
		this.checkboxConvertWindowsMediaAx = document.getElementById('mediawrapConvertWindowsMediaAx');
		this.checkboxConvertWindowsMediaAx.checked = this.getBoolPref('convertWindowsMediaAx', true);

		this.checkboxConvertRealAx = document.getElementById('mediawrapConvertRealAx');	
		this.checkboxConvertRealAx.checked = this.getBoolPref('convertRealAx', true);

		this.checkboxConvertQuickTimeAx = document.getElementById('mediawrapConvertQuickTimeAx');
		this.checkboxConvertQuickTimeAx.checked = this.getBoolPref('convertQuickTimeAx', true);

		this.checkboxConvertShockwaveFlashAx = document.getElementById('mediawrapConvertShockwaveFlashAx');
		this.checkboxConvertShockwaveFlashAx.checked = this.getBoolPref('convertShockwaveFlashAx', true);

		this.checkboxConvertShockwaveDirectorAx = document.getElementById('mediawrapConvertShockwaveDirectorAx');
		this.checkboxConvertShockwaveDirectorAx.checked = this.getBoolPref('convertShockwaveDirectorAx', true);

		this.checkboxConvertObjectNoClassId = document.getElementById('mediawrapConvertObjectNoClassId');
		this.checkboxConvertObjectNoClassId.checked = this.getBoolPref('convertObjectNoClassId', true);

		this.checkboxConvertEmbed = document.getElementById('mediawrapConvertEmbed');
		this.checkboxConvertEmbed.checked = this.getBoolPref('convertEmbed', true);

		this.checkboxConvertBgSound = document.getElementById('mediawrapConvertBgSound');
		this.checkboxConvertBgSound.checked = this.getBoolPref('convertBgSound', true);

		this.checkboxConvertDynsrcImg = document.getElementById('mediawrapConvertDynsrcImg');
		this.checkboxConvertDynsrcImg.checked = this.getBoolPref('convertDynsrcImg', true);

		this.checkboxConvertEachAuto = document.getElementById('mediawrapConvertEachAuto');
		this.checkboxConvertEachAuto.checked = this.getBoolPref('convertEachAuto', true);

		this.checkboxAutoStartEnabled = document.getElementById('mediawrapAutoStartEnabled');
		this.checkboxAutoStartEnabled.checked = this.getBoolPref('autoStartEnabled', true);

		this.checkboxAutoStartBgSound = document.getElementById('mediawrapAutoStartBgSound');
		this.checkboxAutoStartBgSound.checked = this.checkboxAutoStartEnabled.checked ?
			true : this.getBoolPref('autoStartBgSound', true);
		this.checkboxAutoStartBgSound.disabled = this.checkboxAutoStartEnabled.checked;

		this.checkboxAutoStartLocalLinks = document.getElementById('mediawrapAutoStartLocalLinks');
		this.checkboxAutoStartLocalLinks.checked = this.checkboxAutoStartEnabled.checked ?
			true : this.getBoolPref('autoStartLocalLinks', true);
		this.checkboxAutoStartLocalLinks.disabled = this.checkboxAutoStartEnabled.checked;

		this.checkboxAutoStartFlash = document.getElementById('mediawrapAutoStartFlash');
		this.checkboxAutoStartFlash.checked = this.getBoolPref('autoStartFlash', true);

		this.checkboxAutoStartDirector = document.getElementById('mediawrapAutoStartDirector');
		this.checkboxAutoStartDirector.checked = this.getBoolPref('autoStartDirector', true);

		this.checkboxAlwaysShowWmpControl = document.getElementById('mediawrapAlwaysShowWmpControl');
		this.checkboxAlwaysShowWmpControl.checked = this.getBoolPref('alwaysShowWmpControl', true);

		this.checkboxAlwaysShowWmpContextMenu = document.getElementById('mediawrapAlwaysShowWmpContextMenu');
		this.checkboxAlwaysShowWmpContextMenu.checked = this.getBoolPref('alwaysShowWmpContextMenu', true);

		this.checkboxConvertWindowsMediaAx.disabled = this.checkboxConvertRealAx.disabled
			= this.checkboxConvertQuickTimeAx.disabled = this.checkboxConvertShockwaveFlashAx.disabled
			= this.checkboxConvertObjectNoClassId.disabled = this.checkboxConvertEmbed.disabled
			= this.checkboxConvertBgSound.disabled = this.checkboxConvertDynsrcImg.disabled
			= this.checkboxConvertShockwaveDirectorAx.disabled = ! this.checkboxMediawrapEnabled.checked
	},

	// "OK" button was clicked
	onAccept: function() {
		this.setEnabled(this.checkboxMediawrapEnabled.checked);
		this.setBoolPref('convertWindowsMediaAx', this.checkboxConvertWindowsMediaAx.checked);
		this.setBoolPref('convertRealAx', this.checkboxConvertRealAx.checked);
		this.setBoolPref('convertQuickTimeAx', this.checkboxConvertQuickTimeAx.checked);
		this.setBoolPref('convertShockwaveFlashAx', this.checkboxConvertShockwaveFlashAx.checked);
		this.setBoolPref('convertShockwaveDirectorAx', this.checkboxConvertShockwaveDirectorAx.checked);
		this.setBoolPref('convertObjectNoClassId', this.checkboxConvertObjectNoClassId.checked);
		this.setBoolPref('convertEmbed', this.checkboxConvertEmbed.checked);
		this.setBoolPref('convertBgSound', this.checkboxConvertBgSound.checked);
		this.setBoolPref('convertDynsrcImg', this.checkboxConvertDynsrcImg.checked);
		this.setBoolPref('convertEachAuto', this.checkboxConvertEachAuto.checked);
		this.setBoolPref('autoStartEnabled', this.checkboxAutoStartEnabled.checked);
		this.setBoolPref('autoStartLocalLinks', this.checkboxAutoStartLocalLinks.checked);
		this.setBoolPref('autoStartBgSound', this.checkboxAutoStartBgSound.checked);
		this.setBoolPref('autoStartFlash', this.checkboxAutoStartFlash.checked);
		this.setBoolPref('autoStartDirector', this.checkboxAutoStartDirector.checked);
		this.setBoolPref('alwaysShowWmpControl', this.checkboxAlwaysShowWmpControl.checked);
		this.setBoolPref('alwaysShowWmpContextMenu', this.checkboxAlwaysShowWmpContextMenu.checked);
	},

	getEnabled: function() {
		return this.getBoolPref('mediawrapEnabled', true);
	},

	setEnabled: function(bool) {
		this.setBoolPref('mediawrapEnabled', bool);
		var observerSvc = Components.classes["@mozilla.org/observer-service;1"]
				.getService(Components.interfaces.nsIObserverService);
		observerSvc.notifyObservers(null, "mediawrapStatusChanged", null);
	}

};