var mediawrapUtils = {	
	observe: function(subject, topic, data) {
		this.statusChanged();
	},

	register: function() {
		var observerSvc = Components.classes["@mozilla.org/observer-service;1"]
				.getService(Components.interfaces.nsIObserverService);
		observerSvc.addObserver(this, "mediawrapStatusChanged", false);
	},

	unregister: function() {
		var observerSvc = Components.classes["@mozilla.org/observer-service;1"]
				.getService(Components.interfaces.nsIObserverService);
		observerSvc.removeObserver(this, "mediawrapStatusChanged");
	},

	updateStatusIcon: function() {
		var strBundle = document.getElementById("mediawrap-Strings");
		var statusImage = document.getElementById("mediawrap-status-image");
		var statusEnabledItem = document.getElementById("mediawrap-status-enabled-item");
		if ( mediawrapSettings.getEnabled() ) {
			statusImage.src = "chrome://mediawrap/content/images/status_on.png";
			statusImage.tooltipText = strBundle.getString("Enabled");
			statusEnabledItem.setAttribute("checked", true);
		}
		else {
			statusImage.src = "chrome://mediawrap/content/images/status_off.png";
			statusImage.tooltipText = strBundle.getString("Disabled");
			statusEnabledItem.setAttribute("checked", false);
		}
	},

	statusChanged: function() {
		// Only use the new stylesheet api
		var sss = Components.classes["@mozilla.org/content/style-sheet-service;1"]
					.getService(Components.interfaces.nsIStyleSheetService);
		var ios = Components.classes["@mozilla.org/network/io-service;1"]
					.getService(Components.interfaces.nsIIOService);
		var uri = ios.newURI("chrome://mediawrap/content/mediawrap.css", null, null);
		if (mediawrapSettings.getBoolPref('mediawrapEnabled', true)
					&& !sss.sheetRegistered(uri, sss.USER_SHEET)) {
			sss.loadAndRegisterSheet(uri, sss.USER_SHEET);
		}
		else if (!mediawrapSettings.getBoolPref('mediawrapEnabled', true)
					&& sss.sheetRegistered(uri, sss.USER_SHEET)) {
			sss.unregisterSheet(uri, sss.USER_SHEET);
		}

		this.updateStatusIcon();
	},

	getContents :function (aURL) {
		var ioService = Components.classes["@mozilla.org/network/io-service;1"]
			.getService(Components.interfaces.nsIIOService);
		var scriptableStream = Components
			.classes["@mozilla.org/scriptableinputstream;1"]
			.getService(Components.interfaces.nsIScriptableInputStream);
		var channel	=	ioService.newChannel(aURL,null,null);
		var input = channel.open();
		scriptableStream.init(input);
		var str = scriptableStream.read(input.available());
		scriptableStream.close();
		input.close();
		return str;
	},

	execScript: function (text) {
		var scriptElm = content.document.createElement("script");
		scriptElm.appendChild(content.document.createTextNode(text));
		if (content.document.body) {
			content.document.body.appendChild(scriptElm);
			content.document.body.removeChild(scriptElm);
		}
	},
	
	mediawrapCheck: function (e) {
		if ( mediawrapSettings.getBoolPref('mediawrapEnabled', true) ) {
			var obj = e.target;
			var charset = e.view.document.characterSet;
			var mediawrapChecker = new mediawrapCheckMedia();
			mediawrapChecker.go(obj, charset);
			if (mediawrapChecker.setPlaceholder)
				e.preventDefault();
		}
		e.stopPropagation();
		
	},

	onLoad: function() {

		try {
			window.removeEventListener("load", mediawrapUtils.onLoad, true);
		} catch (e) {}

		mediawrapUtils.register();
		mediawrapUtils.statusChanged();
	},

	unLoad: function() {
		mediawrapUtils.unregister();
	}
}

window.addEventListener("load", mediawrapUtils.onLoad, false);
window.addEventListener("unload", mediawrapUtils.unLoad, false);
window.addEventListener("mediawrapCheckLoad", mediawrapUtils.mediawrapCheck, true, true);
